#ifndef compiler_expression_expression_base_h
#define compiler_expression_expression_base_h

#include "../linker/linker_context.h"
#include "../../__common/binaries.h"

namespace expression
{
	//
	// Any expression
	class base
	{
	public:

		base()
		{
		}

		virtual ~base() 
		{
		}

		virtual binary::link link(linker::context& c) = 0;

		virtual int estimate(linker::context& c)
		{
			// Base estimate for any expression - pay for resolve link.
			// If expression more complex than link, it add its own 
			// estimation to base, but not ignore base.
			return 1;
		}

		virtual int estimateApply(linker::context& c, size_t argc, base** args)		
		{
			// apply non function may be valid, but in this case 
			// we can not estimate complexity in compile time. Examples:
			//
			// 1. ((if #t + *) 1 2)
			// 2. (define func (lambda () car)
			//    ((func) '(1 2 3))
			//
			// assume recursive call
			return 1 << 16;
		}
	};
}

#include "../utils/name2type.h"

// Helper for name-2-expression translation
typedef name2ptype<expression::base> name2expr;
#endif
