#ifndef compiler_expression_expression_variable_h
#define compiler_expression_expression_variable_h

#include "expression_base.h"
#include <string>

namespace expression
{
	//
	// Variable expression
	class variable : public base
	{
	public:

		variable(const std::string& v) : m_name(v)
		{
		}

		virtual binary::link link(linker::context& c)
		{
			return c.getLink(m_name);
		}

		virtual int estimate(linker::context& c)
		{
			return 1; //c.getExpr(m_name)->estimate(c);
		}

		virtual int estimateApply(linker::context& c, size_t argc, base** args)
		{
			return c.getExpr(m_name)->estimateApply(c, argc, args);
		}

	private:

		const std::string m_name;
	};
}

#endif
