#include "syntacter_expression.h"
#include "syntacter_literal.h"
#include "syntacter_code.h"
#include "../expression/expression_variable.h"

#include <stdexcept>

////////////////////////////////////////////////////
//
// Any expression
//
/////////////////////////////////////////////////////

//
// Read expression from stream
expression::base* syntacter::read(stream::input<lexer::token>& i)
{
	lexer::token t = i.get();

	if  ((t.type() == lexer::token::quote) || t.isLiteral())
	{
		// Literal
		i.putback(t);
		return read_literal(i);
	}

	if (t.type() == lexer::token::variable)
	{
		// Variable
		return new expression::variable(t.getString());
	}

	if (t.type() == lexer::token::open_bracket)
	{
		// Call | lambda | if | cond | and | or
		return read_code(i);
	}

	throw std::runtime_error("syntacter::read: Unknown expression");
}