#ifndef compiler_syntacter_syntacter_expression_h
#define compiler_syntacter_syntacter_expression_h

#include "../expression/expression_base.h"
#include "../streams/stream_input.h"
#include "../lexer/lexer.h"

namespace syntacter
{
	/*
	<expression> ::= <variable> | <literal> | <procedure call> 
				| <lambda expression> | <conditional> | <derived expression>

		<literal> ::= <quotation> | <self-evaluation>
			<quotation> ::= <datum>
			<self-evaluated> ::= <boolean> | <character> | <string> | <number>
		<procedure call> ::= (<operator> <operand>*)
			<operator> ::= <expression>
			<operand> ::= <expression>
		<lambda expression> ::= (lambda <formals> <body>)
			<formals> ::= (<variable>*) | <variable> | (<variable>+ . <variable>)
			<body> ::= <expression>
			     
		<conditional> ::= (if <test> <consequent> <alternate>)
			<test> ::= <expression>
			<consequence> ::= <expression>
			<alternate> ::= <expression>
		<derived expression> ::= (cond <cond clause>+) 
				| (cond <cond clause>* (else <expression>))
				| (and <test>*) | (or <test>*)
			<cond clause> ::= (<test> <expression>)
	*/

	expression::base* read(stream::input<lexer::token>& i);
}

#endif
