#include "file.h"
#include <stdio.h>

CFile::CFile() : m_file(0)
{
}

CFile::~CFile()
{
	if (m_file)
	{
		fclose(m_file);
	}
}

bool CFile::create(const char* name)
{
	m_file = fopen(name, "wb+");
	return (m_file != 0);
}

bool CFile::createReadOnly(const char* name)
{
	m_file = fopen(name, "wb+");
	return (m_file != 0);
}

bool CFile::openForRead(const char* name)
{
	m_file = fopen(name, "rb");
	return (m_file != 0);
}

long CFile::length()
{
	long current = ftell(m_file); 
	fseek(m_file, 0, SEEK_END);
	long len = ftell(m_file); 
	fseek(m_file, current, SEEK_SET);

	return len;
}

bool CFile::read(char* buff, size_t len)
{
	return (fread(buff, 1, (unsigned int) len, m_file) == len);
}

bool CFile::write(const char* buff, size_t len)
{
	fwrite(buff, 1, (unsigned int) len, m_file);
	return true;
}
