#include "./loader/loader.h"
#include "./object/object_base.h"
#include <exception>

int main(int argc, char* argv[])
{
	if (argc < 2)
	{
		printf("Usage: dump.exe <file> [options]\n");
		return 0;
	}

	try
	{
		// load file
		loader::executable exe(argv[1]);

		for (size_t i = 0; i < exe.size(); i++)
		{
			std::string line = object::create(exe[i]);
			printf("%04d est: %10d %s\n", i, exe[i].estimate(), line.c_str());
		}

		return 0;
	}
	catch (std::exception& e)
	{
		printf("Exception: %s\n", e.what());
	}

	return 0;
}
