#ifndef executer_object_object_code_h
#define executer_object_object_code_h

#include "object_base.h"
#include "../../__common/binaries.h"

namespace object
{
	//
	// Call object
	class call : public base
	{
	public:

		static proxy create(const context::base* c, const loader::record& rec, bool separable);

		virtual proxy evaluate(bool separable) const;
		virtual std::string toString() const;

	private:

		call(const context::base* ctx, const binary::call& c, int est);

	private:

		binary::link m_func;
		std::vector<binary::link> m_operands;
	};

	//
	// if_ object
	class if_ : public base
	{
	public:

		static proxy create(const context::base* c, const loader::record& rec, bool separable);

		virtual proxy evaluate(bool separable) const;
		virtual std::string toString() const;

	private:

		if_(const context::base* ctx, const binary::if_& i, int est);

	private:

		binary::link m_condition;
		binary::link m_consequence;
		binary::link m_alternate;
	};

	/*
		cond,
		and,
		or,
	*/


}

#endif
