#include "mmf.h"
#include "file.h"
#include <stdexcept>

MemoryMappedFile::MemoryMappedFile(const char* name)
{
	CFile f;

	if (!f.openForRead(name))
	{
		throw std::runtime_error("MemoryMappedFile: can not open file");
	}

	long size = f.length();
	m_data.resize(size);

	if (!f.read(&m_data[0], size))
	{
		m_data.resize(0);
		throw std::runtime_error("MemoryMappedFile: can not read file");
	}
}

MemoryMappedFile::~MemoryMappedFile()
{
}

const char* MemoryMappedFile::get() const
{
	return &m_data[0];
}

size_t MemoryMappedFile::size() const
{
	return m_data.size();
}
